(** * Definitions 
    
     Permissions are elements of a set [t] with a decidable equality and a decidable
     partial order [lt] for which [bot] is a minimal element.
*)

Module Type Permission.

  Parameter t : Set.

  Parameter eq_dec : forall p p' : t, {p = p'} + {p <> p'}.

 (* Parameter lt : t -> t -> Prop.

  Parameter lt_irrefl : forall p, ~ lt p p.

  Parameter lt_trans : forall p p' p'', lt p p' -> lt p' p'' -> lt p p''.

  Parameter lt_asym : forall p p', lt p p' -> lt p' p -> False.

  Parameter lt_dec : forall p p' : t, {lt p p'} + {~ lt p p'}. 

  Parameter bot : t.*)

End Permission.